/***************************************************************************
 *   Copyright (c) 2009  Peter Mylemans <peter.mylemans@gmail.com>         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/

#ifndef CONTEXTWIDGET_H
#define CONTEXTWIDGET_H

#include <QFrame>

#include "models/ContextModel.h"
#include "views/ContextView.h"

class ContextWidget : public QFrame
{
    Q_OBJECT
public:
    ContextWidget(QWidget *parent);

    void registerView(ContextView *view);

public slots:
    void changeContext(ContextModel *model);

private:
    ContextView         *m_currentView;
    QList<ContextView*>  m_views;
};

#endif
