/***************************************************************************
 *   Copyright (c) 2009  Peter Mylemans <peter.mylemans@gmail.com>         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/

#include "CollectionBrowser.h"
#include "CollectionTreeDelegate.h"

#include <QTreeView>
#include <QVBoxLayout>

#include "../App.h"

CollectionBrowser::CollectionBrowser(QWidget *parent)
    : QWidget(parent)
{
    QVBoxLayout *layout = new QVBoxLayout(this);
    setLayout(layout);

    QTreeView *treeView = new QTreeView(this);
    m_collectionTreeModel = new CollectionTreeModel(treeView);
    connect(App::self()->collectionManager(), SIGNAL(collectionAdded(Collection*)), m_collectionTreeModel, SLOT(addCollection(Collection*)));

    treeView->setModel(m_collectionTreeModel);
    treeView->setItemDelegate(new CollectionTreeDelegate(treeView));
    treeView->setAlternatingRowColors(true);
    treeView->setRootIsDecorated(false);
    treeView->expandAll();

    connect(treeView, SIGNAL(clicked(QModelIndex)), m_collectionTreeModel, SLOT(selectIndex(QModelIndex)));

    layout->addWidget(treeView);
}

#include <QDebug>
