/***************************************************************************
 *   Copyright (c) 2009  Peter Mylemans <peter.mylemans@gmail.com>         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/

#ifndef COLLECTION_TREEMODEL_H
#define COLLECTION_TREEMODEL_H

#include <QAbstractItemModel>
#include <QList>

#include "Collection.h"

enum CollectionTreeModelRoles
{
    MetricsLine = Qt::UserRole
};

struct TreeItem;

class CollectionTreeModel : public QAbstractItemModel
{
    Q_OBJECT
public:
    CollectionTreeModel(QObject *parent = 0);
    ~CollectionTreeModel();

    QVariant data(const QModelIndex &index, int role) const;
    Qt::ItemFlags flags(const QModelIndex &index) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
    QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const;
    QModelIndex parent(const QModelIndex &index) const;
    int rowCount(const QModelIndex &parent = QModelIndex()) const;
    int columnCount(const QModelIndex &parent = QModelIndex()) const;

public slots:
    void addCollection(Collection *collection);
    void clearCollection();
    void addMovie(const Movie *movie);

    void selectIndex(const QModelIndex &index);

private:
    TreeItem* findCollection(Collection *collection);

private:
    TreeItem *m_RootItem;
};

#endif
