/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#include "documentbuilder.h"

#include "svgparser.h"
#include "direktorinstance.h"
#include "elementdatabase.h"

// KDE
#include <kurl.h>
#include <kdebug.h>


DocumentBuilder::DocumentBuilder(const KURL &url, QObject *parent, const char *name)
    : QObject(parent, name)
{
  if (!url.isLocalFile())
  {
    kdDebug() << k_funcinfo << " - [ERROR] not a local file!!!" << endl;
    return;
  }

  SVGParser parser;
  parser.startDocument( url.path() );

  Kast::self()->elementDB().setDocumentRoot(parser.getDocument());
}


DocumentBuilder::~DocumentBuilder()
{}


#include "documentbuilder.moc"
