/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <qwidget.h>
#include <kxmlguibuilder.h>
#include <kparts/dockmainwindow.h>

class KActionCollection;
class KDockWidget;
class DocumentWidget;
/**
The main container widget
 
@author Hans Oischinger
*/
class MainWindow : public KParts::DockMainWindow //QWidget, public KXMLGUIBuilder
{
  Q_OBJECT
public:
  MainWindow(QWidget *parent, const char *name, KActionCollection *actionCollection);
  ~MainWindow();

  void toggleStrokeDock();
  DocumentWidget *getDocWidget() { return m_docWidget; }

signals:
  void strokeDockToggled(bool);

protected:
  void setupDocks();

private:
  DocumentWidget *m_docWidget;
  KDockWidget* m_mainDock;
  KDockWidget* m_leftDock;
  KDockWidget* m_rightDock;
  KDockWidget* m_topDock;
  KDockWidget* m_strokeDock;
  KDockWidget* m_toolDock;
  KDockWidget* m_styleDock;
};

#endif
