/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#include "angle.h"

#include "kastconstants.h"

Angle::Angle( unsigned int unitType, float valueInSpecifiedUnits )
    : Attribute(ATTR_ANGLE)
{
  newValueSpecifiedUnits(unitType, valueInSpecifiedUnits);
}

Angle::~Angle()
{}

// Helpers
double Angle::todeg(double rad)
{
  return rad / deg2rad;
}

double Angle::torad(double deg)
{
  return deg * deg2rad;
}

void Angle::setValueInSpecifiedUnits( float valueInSpecifiedUnits )
{
  m_valueInSpecifiedUnits = valueInSpecifiedUnits;
}

void Angle::newValueSpecifiedUnits( unsigned int unitType, float valueInSpecifiedUnits )
{
  m_valueInSpecifiedUnits = valueInSpecifiedUnits;
  m_unitType = unitType;
  setValid();
}

float Angle::radValue( )
{
  if ( m_unitType == ANGLE_RAD )
    return m_valueInSpecifiedUnits;
  else
    return torad( m_valueInSpecifiedUnits );
}

float Angle::degValue( )
{
  if ( m_unitType == ANGLE_DEG )
    return m_valueInSpecifiedUnits;
  else
    return todeg( m_valueInSpecifiedUnits );
}
