/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#ifndef VECLIB_H
#define VECLIB_H

#ifndef ABS
#define ABS(a) 		((a) < 0 ? -(a) : (a))
#endif

/**
@author Hans Oischinger
*/
class VecLib
{
public:
  VecLib();
  ~VecLib();

  static double v2SquaredLength( double x, double y );
  static double v2Length( double x, double y );
  static double v2Dot( double x1, double y1, double x2, double y2 );
  static void v2Scale( double & x, double & y, double newlen );
  static void v2Normalize( double& x, double& y );
//   static void v2Combine(double x1, double y1, double x2, double y2,
//                  double& resultX, double& resultY,
//                  double ascl, double bscl);

};

#endif
