/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#ifndef STYLEWIDGET_H
#define STYLEWIDGET_H

#include <qwidget.h>
#include "core/coreinterfaces.h"

class KTabWidget;
class RGBSelWidgetImpl;
class GradientEditorWidget;
/**
Provides Tabs for Color and Gradient selectors
 
@author Hans Oischinger
*/
class StyleWidget : public QWidget, public ElementListenerInterface, public ElementSelectionListenerInterface
{
  Q_OBJECT
public:
  StyleWidget(QWidget *parent = 0, const char *name = 0);
  ~StyleWidget();

  void onElementInserted( ElementNode* );
  void onElementRemoved( ElementNode* );
  void onElementModified( ElementNode* );

  void onSelectionModified();

protected slots:
  void slotRGBValueChanged(const QColor& );
  void updateWidgets();

protected:
  void mouseReleaseEvent( QMouseEvent* );

  /**
   * Sets the color value from the RGBSelWidget on the currently selected element
   */
  void fireRGBCommand();

private:
  KTabWidget* m_tabs;
  RGBSelWidgetImpl* m_rgbSelWidget;
  GradientEditorWidget *m_gradEditor;
  bool m_rgbValDirty;
};

#endif
