/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#ifndef TOOLBOXWIDGET_H
#define TOOLBOXWIDGET_H

#include <qwidget.h>
#include <qptrvector.h>

class GenericTool;
class QVButtonGroup;
class QBoxLayout;
/**
@author Hans Oischinger
*/
class ToolboxWidget : public QWidget
{
  Q_OBJECT
public:
  ToolboxWidget(QWidget *parent = 0, const char *name = 0);
  ~ToolboxWidget();

  QSize sizeHint() const;
  QSize minimumSizeHint() const;
  QSize maximumSizeHint() const;

protected:
  void initTools();

protected slots:
  void slotButtonPressed( int id );
  void slotToolChangedOutside();

private:
  QVButtonGroup *buttonGroup;
  QPtrVector<GenericTool> m_tools;
};

#endif
