/***************************************************************************
 * trackviewcontainer.cpp: implementation of TrackViewContainer class
 *
 * This file is part of KTabEdit, a KDE tabulature editor
 *
 * copyright (C) 2003-2006 the KTabEdit development team <mrgwen@gmail.com>
 * copyright (C) 2002-2003 the KGuitar development team <mrgwen@gmail.com>
 ***************************************************************************/

/***************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * See the file COPYING for more information.
 ***************************************************************************/

#include "trackviewcontainer.h"

TrackViewContainer::TrackViewContainer(TabTrack* tabTrack)
: mTabTrack(tabTrack),
  mCanvas(new QCanvas())
{
}

TrackViewContainer::~TrackViewContainer()
{
	delete mCanvas;
}

TabTrack* TrackViewContainer::tabTrack() const
{
	return mTabTrack;
}

QCanvas* TrackViewContainer::canvas() const
{
	return mCanvas;
}
