/*
Copyright 2008  Nathan Bradshaw nathanlbradshaw@gmail.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public 
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SMODQUERY_P_H
#define SMODQUERY_P_H


#include <QtCore/QHash>
#include <QtCore/QString>
#include <QtCore/QVariant>

// Namespace
namespace ServiceModel { 

class Service;

class QueryPrivate
{
   public:
      
      int m_id;
      QHash<QString, QVariant> m_queryParameters;
      Service *m_service;
      
      virtual ~QueryPrivate() {}
      
      int newId() { 
         static int currentId = 0;
         return currentId++;
      }
      void addQueryParameter(const QString key, const QVariant val) { m_queryParameters[key] = val; }
};

} 
#endif //SMODQUERY_P_H

