/*  This file is part of the KDE project
    Copyright (C) 2007 Matthias Kretz <kretz@kde.org>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) version 3.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

*/

#ifndef PROXYBACKEND_VIDEODATAOUTPUT_H
#define PROXYBACKEND_VIDEODATAOUTPUT_H

#include <phonon/experimental/videoframe.h>

#include <QtCore/QObject>
#include <QtCore/QSize>

#include "proxyobject.h"

namespace Phonon
{
namespace Proxy
{

class VideoDataOutput : public QObject, public ProxyObject
{
    Q_OBJECT
    public:
        VideoDataOutput(QObject *parent);
        ~VideoDataOutput();

    public slots:
        int frameRate() const;
        void setFrameRate(int frameRate);

        QSize naturalFrameSize() const;
        QSize frameSize() const;
        void setFrameSize(const QSize &frameSize);

        quint32 format() const;
        void setFormat(quint32 fourcc);

    signals:
        void frameReady(const Phonon::Experimental::VideoFrame &frame);
        void endOfMedia();
};
}} //namespace Phonon::Proxy

#endif // PROXYBACKEND_VIDEODATAOUTPUT_H
